//+------------------------------------------------------------------+
//|                                          NB Meter_Signals_v2.mq4 |
//|                                 Copyright  2010.02.16, SwingMan |
//| Edited for NanningBob H4 systems                                 |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2010.02.16, SwingMan"
#property  link      ""

//---- indicator settings
//#property  indicator_separate_window
#property  indicator_chart_window

#property  indicator_buffers 2
#property  indicator_color1  Turquoise
#property  indicator_color2  Magenta //OrangeRed

#property  indicator_width1  1
#property  indicator_width2  1

//---- indicator parameters
//+------------------------------------------------------------------+
extern int Period_Back = 120; // 4H = 6 bars/day * 20 days = 120 bars
extern bool Draw_Arrows = false;
extern bool Draw_VerticalLines = true;
extern bool Price_Filter25 = true;
extern string ____Arrows____ = "";
extern int Arrow_UP = 233;
extern int Arrow_DN = 234;
extern string ____MACD____ = "";
extern int FastEMA=12;
extern int SlowEMA=26;
extern int Upper_Limit = 85;
extern int Lower_Limit = 15;
extern string ____RSI____ = "";
extern int Period_RSI = 5;
extern int Upper_Limit1 = 90;
extern int Upper_Limit2 = 70;
extern int Lower_Limit1 = 30;
extern int Lower_Limit2 = 10;
extern string ____Stochastic_1____ = "";
extern int K_Period1 = 7;
extern int Slowing1 = 3;
extern string ____Stochastic_2____ = "";
extern int K_Period2 = 14;
extern int Slowing2 = 5;
//+------------------------------------------------------------------+
int D_Period = 3;

//---- constants
string sObjNameSig = "NB_Signal_";

//---- indicator buffers
double Signal_UP[], Signal_DN[];
double MACD[];
double Macd_UP[], Macd_DN[], Macd_NO[];
double RSI[];
double RSI_UP[], RSI_DN[], RSI_NO[];
double Stoch1[], Stoch_UP1[], Stoch_DN1[], Stoch_NO1[];
double Stoch2[], Stoch_UP2[], Stoch_DN2[], Stoch_NO2[];
double HighPrice[], LowPrice[];

//---- variables
double upper_Limit, lower_Limit;
double upper_Limit1, lower_Limit1;
double upper_Limit2, lower_Limit2;
int iWindow;
string sWindowName;
int limit;
color colorLong, colorShort;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   ArraySetAsSeries(MACD,true);
   ArraySetAsSeries(RSI,true);
   ArraySetAsSeries(Stoch1,true);
   ArraySetAsSeries(Stoch2,true);
   ArraySetAsSeries(HighPrice,true);
   ArraySetAsSeries(LowPrice,true);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,Signal_UP); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,Arrow_UP); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,Signal_DN); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,Arrow_DN); SetIndexLabel(1,NULL);

//---- name for DataWindow and indicator subwindow label
   sWindowName = "NB Meter_Signals_v2";
   IndicatorShortName(sWindowName);
   iWindow = 0;
   colorLong = indicator_color1; 
   colorShort= indicator_color2;

//---- drawing settings   
   SetIndexDrawBegin(0,SlowEMA);
   SetIndexDrawBegin(1,SlowEMA);
   IndicatorDigits(Digits);
//----   
   upper_Limit  = Upper_Limit*1.0;
   lower_Limit  = Lower_Limit*1.0;
   upper_Limit1 = Upper_Limit1*1.0;
   lower_Limit1 = Lower_Limit1*1.0;
   upper_Limit2 = Upper_Limit2*1.0;
   lower_Limit2 = Lower_Limit2*1.0;
//---- initialization done
   return(0);
}

int deinit()
{
   for (int i=0; i<Bars; i++)
      Delete_VerticalLine(i);
return(0);
}

//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
{
int i, iSignal;

   ArrayResize(MACD,Bars);
   ArrayResize(RSI,Bars);
   ArrayResize(Stoch1,Bars);
   ArrayResize(Stoch2,Bars);
   ArrayResize(HighPrice,Bars);
   ArrayResize(LowPrice,Bars);
      
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
//---- indicators
   for(i=0; i<limit; i++)
   {
      MACD[i] = iMA(Symbol(),Period(),FastEMA,0,MODE_EMA,PRICE_CLOSE,i) - 
                iMA(Symbol(),Period(),SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
                
      RSI[i] = iRSI(Symbol(),Period(),Period_RSI,PRICE_WEIGHTED,i);          
      
      Stoch1[i] = iStochastic(Symbol(),Period(), K_Period1,D_Period,Slowing1, MODE_LWMA,1,MODE_MAIN,i);
      Stoch2[i] = iStochastic(Symbol(),Period(), K_Period2,D_Period,Slowing2, MODE_LWMA,1,MODE_MAIN,i);
      
      HighPrice[i] = High[i];
      LowPrice[i]  = Low[i];
   }

   int firstVisibleBar = WindowFirstVisibleBar();
   int barsPerChart    = WindowBarsPerChart();
   int lastVisibleBar  = firstVisibleBar - barsPerChart;
   if (lastVisibleBar <0 ) lastVisibleBar = 0;
   int nBars = firstVisibleBar - lastVisibleBar;
   
//---- signals   
   //for(i=0; i<limit; i++)
   for(i=lastVisibleBar; i<firstVisibleBar; i++)
   {
      int MACD_Condition = Get_MACD_Condition(i);
      int RSI_Condition  = Get_RSI_Condition(i);
      int Stoch1_Condition  = Get_Stoch_Condition(i, Stoch1);
      int Stoch2_Condition  = Get_Stoch_Condition(i, Stoch2);
      if (Price_Filter25)
           int Close_Condition = Get_Close_Condition(i);
      else Close_Condition = true;
      
      iSignal=0;
      //---- long signal --------------------------------------------
      if (MACD_Condition==1 && RSI_Condition==1 && 
          Stoch1_Condition==1 && Stoch2_Condition==1 && Close_Condition==1)
      {    
         iSignal = 1;
      }
      else   
      //---- short signal -------------------------------------------
      if (MACD_Condition==-1 && RSI_Condition==-1 && 
          Stoch1_Condition==-1 && Stoch2_Condition==-1 && Close_Condition==-1)
      {
         iSignal = -1;         
      }   
      //=============================================================
      //---- draw long signal ---------------------------------------
      if (iSignal ==1)
      {
         if (Draw_Arrows) Draw_Arrow(i, iSignal);
         if (Draw_VerticalLines) Draw_VerticalLine(i, colorLong);
      }
      else
      //---- draw short signal --------------------------------------
      if (iSignal ==-1)
      {
         if (Draw_Arrows) Draw_Arrow(i, iSignal);
         if (Draw_VerticalLines) Draw_VerticalLine(i, colorShort);
      }
      else
      //---- no signal ----------------------------------------------
      {
         if (Draw_Arrows) Delete_Arrows(i);
         if (Draw_VerticalLines) Delete_VerticalLine(i);
      }
   }

//---- done
   return(0);
}
//+------------------------------------------------------------------+

//___________________________________________________________________
void Draw_Arrow(int i, int Signal)
{
   double dMax = WindowPriceMax(0);
   double dMin = WindowPriceMin(0);
   double dATR = iATR(Symbol(),Period(),34,1);
   //double dOffset = dATR * 0.50;
   double dOffset = (dMax - dMin) / 100 + dATR;
   //---- long
   if (Signal == 1)
   {
      Signal_UP[i] = Low[i] - dOffset; 
      Signal_DN[i] = EMPTY_VALUE;
   }
   else   
   //---- short
   if (Signal == -1)
   {
      Signal_UP[i] = EMPTY_VALUE; 
      Signal_DN[i] = High[i] + dOffset;   
   }
   else
   //---- no
   if (Signal == 0)
   {
      Signal_UP[i] = EMPTY_VALUE; 
      Signal_DN[i] = EMPTY_VALUE;   
   }
}

//___________________________________________________________________
void Delete_Arrows(int i)
{
   Signal_UP[i] = EMPTY_VALUE; 
   Signal_DN[i] = EMPTY_VALUE;
}

//___________________________________________________________________
void Draw_VerticalLine(int i, color dColor)
{
   string sObjName = sObjNameSig + TimeToStr(Time[i]);
   ObjectCreate(sObjName,OBJ_VLINE,iWindow,Time[i],Close[i]);
      ObjectSet(sObjName,OBJPROP_COLOR,dColor);
}

//___________________________________________________________________
void Delete_VerticalLine(int i)
{
   string sObjName = sObjNameSig + TimeToStr(Time[i]);
   if (ObjectFind(sObjName) != -1)
      ObjectDelete(sObjName);
}

//___________________________________________________________________
int Get_MACD_Condition(int i)
{
double dMACD;
double minMACD, maxMACD, diffMACD;
   
//---- max/min MACD on chart
   int firstVisibleBar = WindowFirstVisibleBar();
   int barsPerChart    = WindowBarsPerChart();
   int lastVisibleBar  = firstVisibleBar - barsPerChart;
   if (lastVisibleBar <0 ) lastVisibleBar = 0;
   int nBars = firstVisibleBar - lastVisibleBar;

   minMACD = MACD[ArrayMinimum(MACD,nBars,lastVisibleBar)];
   maxMACD = MACD[ArrayMaximum(MACD,nBars,lastVisibleBar)];
   diffMACD = maxMACD - minMACD;

//---- check
   if (i>=lastVisibleBar && i<=firstVisibleBar)
   {                     
      if (diffMACD != 0)
         dMACD = 100*(MACD[i] - minMACD) / diffMACD;

      diffMACD = maxMACD - minMACD;   
      if (diffMACD != 0)
         dMACD = 100*(MACD[i] - minMACD) / diffMACD;
      
      //---- MACD > upper_Limit => short
      if (dMACD > upper_Limit) return(-1);
      else
      //---- MACD < lower_Limit => long
      if (dMACD < lower_Limit) return(1);
      else
      //---- neutral
         return(0);
   }
   return(0);   
}

//___________________________________________________________________
int Get_Close_Condition(int i)
{
double dHigh, dLow;
double upperLine4, lowerLine4;
//double minPrice, maxPrice, diffPrice;*/
double maxValue, minValue, diff25;

   //---- max/min last 120 bars
   maxValue = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, Period_Back, i));
   minValue = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, Period_Back, i));
   diff25 = (maxValue - minValue) * 0.25;
      
   upperLine4 = maxValue - diff25;
   lowerLine4 = minValue + diff25;
/*   
//---- max/min last 120 bars
   int firstVisibleBar = WindowFirstVisibleBar();
   int barsPerChart    = WindowBarsPerChart();
   int lastVisibleBar  = firstVisibleBar - barsPerChart;
   if (lastVisibleBar <0 ) lastVisibleBar = 0;
   int nBars = firstVisibleBar - lastVisibleBar;
      
   //minPrice = Low[ArrayMinimum(LowPrice,nBars,lastVisibleBar)];
   //maxPrice = High[ArrayMaximum(HighPrice,nBars,lastVisibleBar)];
   minPrice = WindowPriceMin(0);
   maxPrice = WindowPriceMax(0);
   diffPrice = maxPrice - minPrice;
   dPrice4   = diffPrice * 0.25;
   upperLine4= maxPrice - dPrice4;
   lowerLine4= minPrice + dPrice4;*/   
//if (i==0)
//Comment(minPrice,"  ",maxPrice,"  ",upperLine4,"  ",lowerLine4);

   dHigh = High[i]; 
   dLow  = Low[i];
//---- check
//   if (i>=lastVisibleBar && i<=firstVisibleBar)
//   {                           
      //---- price > upper_Limit => short
      if (dHigh > upperLine4) return(-1);
      else
      //---- price < lower_Limit => long
      if (dLow < lowerLine4) return(1);
      else
      //---- neutral
         return(0);
//   }   
}

//___________________________________________________________________
int Get_RSI_Condition(int i)
{
double dRSI;

   dRSI = RSI[i];
      
   //---- RSI > upper_Limit => short
   if (dRSI < upper_Limit1 && dRSI > upper_Limit2) return(-1);
   else
   //---- RSI < lower_Limit => long
   if (dRSI < lower_Limit1 && dRSI > lower_Limit2) return(1);
   else
   //---- neutral
       return(0);
}

//___________________________________________________________________
int Get_Stoch_Condition(int i, double& Stoch[])
{
double dStoch;

   dStoch = Stoch[i];
      
   //---- Stoch > upper_Limit => short
   if (dStoch > upper_Limit) return(-1);
   else
   //---- Stoch < lower_Limit => long
   if (dStoch < lower_Limit) return(1);
   else
   //---- neutral
       return(0);
}

/*
//___________________________________________________________________
int Get_Close_Condition(int i)
{
double dHigh, dLow;
double dPrice4, upperLine4, lowerLine4;
double minPrice, maxPrice, diffPrice;
   
//---- max/min MACD on chart
   int firstVisibleBar = WindowFirstVisibleBar();
   int barsPerChart    = WindowBarsPerChart();
   int lastVisibleBar  = firstVisibleBar - barsPerChart;
   if (lastVisibleBar <0 ) lastVisibleBar = 0;
   int nBars = firstVisibleBar - lastVisibleBar;
      
   //minPrice = Low[ArrayMinimum(LowPrice,nBars,lastVisibleBar)];
   //maxPrice = High[ArrayMaximum(HighPrice,nBars,lastVisibleBar)];
   minPrice = WindowPriceMin(0);
   maxPrice = WindowPriceMax(0);
   diffPrice = maxPrice - minPrice;
   dPrice4   = diffPrice * 0.25;
   upperLine4= maxPrice - dPrice4;
   lowerLine4= minPrice + dPrice4;
//if (i==0)
//Comment(minPrice,"  ",maxPrice,"  ",upperLine4,"  ",lowerLine4);
   dHigh = High[i]; 
   dLow  = Low[i];
//---- check
   if (i>=lastVisibleBar && i<=firstVisibleBar)
   {                           
      //---- price > upper_Limit => short
      if (dHigh > upperLine4) return(-1);
      else
      //---- price < lower_Limit => long
      if (dLow < lowerLine4) return(1);
      else
      //---- neutral
         return(0);
   }   
}*/